您的位置:首页 > 其它

hdu 5366 The mook jong

2015-08-08 22:51 197 查看
hdu 5366的传送门

ZJiaQ want to become a strong man, so he decided to play the mook jong。ZJiaQ want to put some mook jongs in his backyard. His backyard consist of n bricks that is 1*1,so it is 1*n。ZJiaQ want to put a mook jong in a brick. because of the hands of the mook jong, the distance of two mook jongs should be equal or more than 2 bricks. Now ZJiaQ want to know how many ways can ZJiaQ put mook jongs legally(at least one mook jong).

Input

There ar multiply cases. For each case, there is a single integer n( 1 < = n < = 60)

Output

Print the ways in a single line for each case.

Sample Input

1

2

3

4

5

6

Sample Output

1

2

3

5

8

12

题目大意:ZJiaQ为了强身健体,决定通过木人桩练习武术。ZJiaQ希望把木人桩摆在自家的那个由1*1的地砖铺成的1*n的院子里。由于ZJiaQ是个强迫症,所以他要把一个木人桩正好摆在一个地砖上,由于木人桩手比较长,所以两个木人桩之间地砖必须大于等于两个,现在ZJiaQ想知道在至少摆放一个木人桩的情况下,有多少种摆法。

解题思路:就是找规律,注意long long ,规律::

dp[i] = dp[i-1]+dp[i-3]+1;

[code]#include <iostream>
#include <cstdio>
using namespace std;
__int64 dp[62];
int main()
{
    int m;
    dp[1]=1;
    dp[2]=2;
    dp[3]=3;
    for(int i=4; i<61; i++)
        dp[i] = dp[i-1]+dp[i-3]+1;
    while(~scanf("%d",&m))
    {
        printf("%I64d\n",dp[m]);
    }
    return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: